getSystemMiddleVersion() {
    str=$1
    part=${str%.*}
    part=${part#*.}
    # We append 0 to force to return an integer
    echo $((part+0))
}

shouldConvertXibs() {
    MIDDLE_VERSION=$(getSystemMiddleVersion $1)
    if [ $MIDDLE_VERSION -le 10 ]; then
        echo 1
            else
        echo 0
    fi
}

checkAndConvertXibs() {
    FULL_SYSTEM_VERSION=$(sw_vers -productVersion)
    SHOULD_CONVERT=$(shouldConvertXibs $FULL_SYSTEM_VERSION)
    $(convertXibs $1 $SHOULD_CONVERT)
}

convertXibs() {
    ITERATION_DIRECTORY="${PROJECT_DIR}"
    LOG_FILE="$ITERATION_DIRECTORY/Remove_xibs_logs.txt"
    SHOULD_LOG=$1
    SHOULD_CONVERT=$2

    # Enable log in file if necessary
    if [ $SHOULD_LOG = 1 ]; then
        touch $LOG_FILE
        # Redirect output stream to the log file
        exec > $LOG_FILE
    fi

    echo "Begining xib conversion process"

    if [ $SHOULD_CONVERT = 1 ]; then
        REPLACEMENT_TEXT='<capability name=\"documents saved in the Xcode 8 format\" minToolsVersion=\"8.0\"\/>'
        FILE_EXTENSION='xib'
        FILE_EXTENSION2='storyboard'
        # Set internal field separator to the newline character
        IFS=$'\n'
        # Find all .xib files recursively
        XIB_FILES=$(find $ITERATION_DIRECTORY -name "*.$FILE_EXTENSION" -o -name "*.$FILE_EXTENSION2")

        for XIB_FILE in $XIB_FILES; do
            sed -i '' "s/$REPLACEMENT_TEXT//" $XIB_FILE
            echo "Deleted unnecessary string in $XIB_FILE"
        done
    else
        echo "This system version doesn't require to convert xibs"
    fi

    if [ $SHOULD_LOG = 1 ]; then
        open -e $LOG_FILE
    fi
}

$(checkAndConvertXibs 0)
